﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace ProjectAttempt1
{
	// Creates the window for the user to enter their information about themselves and their hometown
    public partial class EnterHometownBox: Window
    {
        public EnterHometownBox(string defaultName = "", string defaultHometown = "", string defaultState = "")
        {
            InitializeComponent();

			//Name
			txtName.Text = defaultName;
			//Hometown
			txtHometown.Text = defaultHometown;
			//State
			txtState.Text = defaultState;
			// Ok button
			btnDialogOk.IsEnabled = false;

        }

		// What the window will do when the user presses Ok
		private void BtnDialogOk_Click(object sender, RoutedEventArgs e)
		{
			this.DialogResult = true;
			
		}

		private void Window_ContentRendered(object sender, EventArgs e)
		{
			txtName.SelectAll();
			txtName.Focus();
		}

		// Checks whenever text is changed in any of the fields. This is tied to the textBoxes in the XAML code
		private void TextChangedEventHandler(object sender, EventArgs e)
		{
			// Checks to make sure that data has been initialized and then makes sure that data is not left blank
			// so that the user enters all of the required data before being able to click ok
			if (txtName != null && txtHometown != null && txtState != null && btnDialogOk != null)
			{
				if (txtName.Text == "" || txtHometown.Text == "" || txtState.Text == "")
					btnDialogOk.IsEnabled = false;
				else
					btnDialogOk.IsEnabled = true;
			}
		}

		public string HTName
		{
			get { return txtName.Text; }
		}

		public string HTHometown
		{
			get { return txtHometown.Text; }
		}

		public string HTState
		{
			get { return txtState.Text; }
		}
	}
}
