﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Forms;
using System.Collections.Specialized;
using System.Net;
using System.IO;
using System.Text.Json;
using System.Xaml.Schema;

namespace ProjectAttempt1
{

    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            // Runs the file GoogleMaps.html to create the Google Map using the API key and runs it through the WebBrowser
            Uri uri = new Uri("http://compsci02.snc.edu/~pfotsm/GoogleMaps/GoogleMaps.html", UriKind.RelativeOrAbsolute);
            this.myWebBrowser.Navigate("http://www.google.com/?refresh=");
            this.myWebBrowser.Navigate(uri);
        }

        // What happens when the user press the Enter Hometown Button
        // Calls the EnterHometownBox
        // When it returns, runs through the data and stores it in a file
        private void EnterHometown(object sender, RoutedEventArgs e)
        {
            //Enter your hometown button
            EnterHometownBox entHometown = new EnterHometownBox();
            bool? dialogResult = entHometown.ShowDialog();
            String htHometown;
            String htName;
            String htState;
            switch (dialogResult)
            {
                case true:
                    // User accepted dialog box
                    htHometown = entHometown.HTHometown;
                    htState = entHometown.HTState;
                    htName = entHometown.HTName;

                    string URL = "http://compsci02.snc.edu/~pfotsm/GoogleMaps/postHandler.php";
                    WebClient webClient = new WebClient();
                    NameValueCollection formData = new NameValueCollection();

                    //Using my API key and the data recieved from user, data is sent to the geocode api to get data back from google
                    // Using this to get the lat and lng out of data that is recieved
                    string yourapikey = "AIzaSyC1aGvKBjIhXGmyfOlu4sFmdXwm4oY9aNc";
                    string url = String.Format("https://maps.googleapis.com/maps/api/geocode/json?key={0}&address={1},{2}", yourapikey, htHometown, htState);
                    string urlResponse = URLRequest(url);

                    //Parses data from geocode api request to get lat and lng from the hometown and state
                    //Logic found on Microsoft
                    JsonDocument document = JsonDocument.Parse(urlResponse);
                    JsonElement root = document.RootElement;
                    JsonElement resEl = root.GetProperty("results");

                    String lat = "lat";
                    String lng = "lng";
                    foreach (JsonElement results in resEl.EnumerateArray())
                    {
                        if(results.TryGetProperty("geometry", out JsonElement geoEl))
                        {
                            if (geoEl.TryGetProperty("location", out JsonElement locEl))
                            {
                                locEl.TryGetProperty("lat", out JsonElement locLat);
                                locEl.TryGetProperty("lng", out JsonElement locLng);
                                lat = locLat.GetRawText();
                                lng = locLng.GetRawText();
                            }
                        } 
                    }

                    // Sets data to be sent to postHandler.php to format in to JSON to be put in locations.txt
                    String place = htHometown + ", " + htState;
                    formData["name"] = htName;
                    formData["city"] = place;
                    formData["lat"] = lat;
                    formData["lng"] = lng;

                    byte[] responseBytes = webClient.UploadValues(URL, "POST", formData);
                    string responsefromServer = Encoding.UTF8.GetString(responseBytes);

                    // added to help force refresh of browser so pins update?
                    this.myWebBrowser.Refresh(true);

                    // forces update of the browser so html file is recalled with new data in the locations file for it to traverse thru
                    Uri uri = new Uri("http://compsci02.snc.edu/~pfotsm/GoogleMaps/GoogleMaps.html", UriKind.RelativeOrAbsolute);
                    this.myWebBrowser.Navigate("http://www.google.com/?refresh=");
                    this.myWebBrowser.Navigate(uri);

                    // another attempt at forcing browser to refresh
                    this.myWebBrowser.Refresh(true);

                    break;
                case false:
                    // User canceled dialog box
                    break;
            }
        }

        //Inside of function comes from Microsoft
        public static string URLRequest(string url)
        {
            // Prepare the Request
            HttpWebRequest request = (HttpWebRequest)WebRequest.Create(url);

            // Set method to GET to retrieve data
            request.Method = "GET";
            request.Timeout = 6000; //60 second timeout
            request.UserAgent = "Mozilla/5.0 (compatible; MSIE 9.0; Windows Phone OS 7.5; Trident/5.0; IEMobile/9.0)";

            string responseContent = null;

            // Get the Response
            using (WebResponse response = request.GetResponse())
            {
                // Retrieve a handle to the Stream
                using (Stream stream = response.GetResponseStream())
                {
                    // Begin reading the Stream
                    using (StreamReader streamreader = new StreamReader(stream))
                    {
                        // Read the Response Stream to the end
                        responseContent = streamreader.ReadToEnd();
                    }
                }
            }

            return (responseContent);
        }
    }
}

